<login>
    <!-- View -->
    <div class="container login">
        <main id="content" class="widget-login-container" role="main">
            <div class="row">
                <div class="col-lg-12 col-sm-12 col-xs-12 d-flex justify-content-center">
                    <!--Login Box -->
                    <section class="widget-login center-block">
                        <header>
                            <div class="logo">
                                <img src="assets/images/GPSDBrogo6-3.png" style="height:35px;margin-right:10px;">
                                <span>CloudGPS3管理画面</span>
                            </div>
                        </header>
                        <div class="widget-body">
                            <div class="text-danger message">{ props.message || state.message}</div>
                            <div class="text-danger messages" each="{message in state.messages}">{ message}</div>
                            <form id="frmLogin" class="login-form mt-lg" data-parsley-priority-enabled="false" novalidate="novalidate">
                                <div class="form-group">
                                    <input ref="loginId" id="loginId" name="loginId" class="form-control" required="required" placeholder="アカウントID" value="{ state.loginId }"/>
                                </div>
                                <div class="form-group">
                                    <input ref="password" id="password" name="password" type="password" class="form-control" required="required" placeholder="パスワード" value="{ state.password }"/>
                                </div>
                                <div class="form-group">
                                    <div class="checkbox widget-login-info pull-left p-0">
                                        <input ref="checkbox" type="checkbox" id="checkbox1" checked="{ state.checked }">
                                        <label for="checkbox1">パスワードを保存</label>
                                    </div>
                                </div>
                            </form>
                            <div class="col-lg-12 col-sm-12 col-xs-12 text-center login-btn">
                                <button class="btn btn-primary btn-sm" type="button" onclick="{ onLoginClick }">ログイン</button>
                            </div>
                        </div>
                    </section>
                    <section>
                        <div class="official">
                            <a href="http://cloudgps.co.jp" target="_blank"><img src="assets/images/official_site.png" alt="CloudGPS" width="220"/></a>
                        </div>
                    </section>
                    <!--Login Box End-->
                </div>
            </div>
        </main>
    </div>
    <script>
        export default {
            service: new UserService(),
            messages: [],
            onBeforeMount(props, state) {
                this.logoutModal = props.logoutModal
            },
            onMounted(props, state) {

                document.title = 'ログイン';
                document.body.className = "login-page";

                const loginId = $.cookie("loginId") || ""
                const password = $.cookie("password") || ""
                const checked = $.cookie("checked")

                this.update({
                    loginId: loginId,
                    password: password,
                    checked : checked
                })

                $("#menuclick").on('click', function(e) {
                    e.preventDefault()
                    $("#wrapper").toggleClass("locked")
                })

                if(!$("#wrapper").hasClass("locked")){
                    $("#sidebar-wrapper").hover(function(e) {
                        e.preventDefault()
                        $("#wrapper").toggleClass("toggled")
                        $("#sidebar-wrapper").toggleClass("scroll")
                    })
                }

            },
            async onLoginClick() {
                const self = this
                const service = this.service
                const loginId = this.$("[ref='loginId']").value
                const password = this.$("[ref='password']").value
                const check = this.$("[ref='checkbox']").checked
                if (check) {
                    $.cookie("loginId", loginId, {expires: 14})
                    $.cookie("password", password, {expires: 14})
                    $.cookie("checked", true, {expires: 14})
                } else {
                    $.removeCookie("loginId")
                    $.removeCookie("password")
                    $.removeCookie("checked")
                }
                this.update({
                    message : "",
                    messages: []
                })
                $(".widget-body").css("height", "180px")

                this.messages = []

                // バリデーション
                const validLoginId = v8n().not.null().not.empty().string().test(loginId)
                const validPassword = v8n().not.null().not.empty().string().test(password)
                if (!validLoginId) {
                    this.messages.push("メールアドレスを入力して下さい")
                }

                if (!validPassword) {
                    this.messages.push("パスワードを入力して下さい")
                }

                if (this.messages.length > 0) {
                    this.update({
                        messages: this.messages
                    })
                    $(".widget-body").css("height", "220px")
                    return
                }

                const response = await service.login(loginId, password)

                if (response.statusCode == 200) {

                    UserInfo.getInstance().setEmail(response.data.email)
                    UserInfo.getInstance().setName(response.data.name)
                    UserInfo.getInstance().setAdminpass(response.data.adminnpass)
                    UserInfo.getInstance().setPassword(response.data.password)
                    UserInfo.getInstance().setLoginType(response.data.loginType)
                    const apiKey = MapUtil.getApiKey()
                    localStorage.setItem('apiKey', apiKey)

                    await ApiKeyUtil.fetchApiKeys()

                    // メニュー
                    riot.unmount("content", {}, "login")
                    if (UserInfo.getInstance().getLoginType() == Const.ACCOUNT_TYPE_ADMIN) {
                        // 管理者
                        riot.mount("content", {
                            menus: Const.ADMIN_MENUS,
                            logoutModal: this.logoutModal
                        }, "top")
                    } else if (UserInfo.getInstance().getLoginType() == Const.ACCOUNT_TYPE_USER) {
                        // 一般ユーザー
                        riot.mount("content", {
                            menus: Const.USER_MENUS,
                            logoutModal: this.logoutModal
                        }, "top")
                    } else if (UserInfo.getInstance().getLoginType() == Const.ACCOUNT_TYPE_GROUP){
                        UserInfo.getInstance().setGroupId(response.data.groupId)
                        // グループID
                        riot.mount("content", {
                            menus: Const.GROUP_MENUS,
                            logoutModal: this.logoutModal
                        }, "top")
                    } else {
                        UserInfo.getInstance().setEmail(response.data.assetId)
                        UserInfo.getInstance().setAssetId(response.data.assetId)
                        // 個人端末
                        riot.mount("content", {
                            menus: Const.ASSET_MENU,
                            logoutModal: this.logoutModal
                        }, "top")
                    }


                } else {
                    // ログインに失敗
                    self.update({
                        message : response.message
                    })
                    $(".widget-body").css("height", "220px")
                }
            }
        }
    </script>
</login>
